/*    GS1.PRG
      Crea una Tabla de Prefijos GS1 
      Vea : http://www.gs1.org/barcodes/support/prefix_list
      se incluye tabla de banderas conteniendo 121 imagenes
      para incluir en su aplicacion POS (Punto de Venta)
      y controlar el origen de los productos.
      se distribuye como es, este codigo puede tener errores
      que pueden ser subsanados en posibles actualizaciones
      estas actualizacines sern publicadas pero sin 
      derecho a recibir notificacin sobre las mismas.
      
      Fue desarrolado en Harbour con el IDE de Roberto Lopez.
      Harbour    : http://harbour-project.sourceforge.net/
      HMG.3.0.42 : http://sourceforge.net/projects/hmg/files/HMG3/HMG.3.0.42.exe/download
      HMG Forum  : http://hmgforum.com/
      
      Gracias a Jair Phino por la ayuda no resuelta con AllTrim()
      Gracias a Grigory Filatov por el consejo a seguir
      
      Este material usa este tipo de licencia.
      http://creativecommons.org/licenses/by-sa/3.0/
      
      
      
      GS1.PRG
      Create a Table of GS1 Prefixes
      See: http://www.gs1.org/barcodes/support/prefix_list
      table is included containing 121 images of flags
      to include in your application POS (Point of Sale)
      and controlling the origin of the products.
      is distributed as is, this code may have errors
      that can be solved in any updates
      These updates will be published without
      entitled to receive notice of them.
      
      It was developed mainly with the IDE Harbour Roberto Lopez.
      Harbour: http://harbour-project.sourceforge.net/
      HMG.3.0.42: http://sourceforge.net/projects/hmg/files/HMG3/HMG.3.0.42.exe/download
      HMG Forum: http://hmgforum.com/
      
      With the help Jair Phino unresolved with ALLTRIM ()
      Thanks to Grigory Filatov by the council to continue
      
      This material uses this type of license.
      http://creativecommons.org/licenses/by-sa/3.0/
      
      DaNiElMaXiMiLiAnO            danielmaximiliano@yahoo.com.ar */
      
#include 'hmg.ch'

PROCEDURE Main()

Public aImages      := {}    
Public aCargarItems := {} 
Public bColor := { || if ( This.CellRowIndex/2 == int(This.CellRowIndex/2) , { 245,245,245 } , { 255,255,255 } ) }	
Public fColor := { || if ( This.CellRowIndex/2 == int(This.CellRowIndex/2) , { 0,0,150 } , { 0,0,0 } ) }	

nBegSeco := SECO()

   Load Window .\Formularios\prefixgs1 
   prefixgs1.Center 
   prefixgs1.Activate

RETURN // Main()

Function Main_2

Local  aStruct := { { "PREFIX", "C" , 3, 0 }, ;
                    { "IMAGE" , "N" , 3, 0 }, ;
                    { "NOMBRE", "C" ,25, 0 }  }
                    
Local aField   := { "PREFIX" , ;
                    "NOMBRE" , ;
                    "IMAGE"  }
                    
Public  nFor          := 0
Public  nOrden        := 1
  
   REQUEST DBFCDX, DBFFPT         // Use FoxPro Database
   RDDSETDEFAULT ('DBFCDX')
   
   SET LANGUAGE TO SPANISH  
   SET INTERACTIVECLOSE ON 
   SET SOFTSEEK ON
   SET NAVIGATION EXTENDED
   SET DELETE ON
   SET DEFAULT TO 'C:\GS1\Bases\'
   
   DBUSEAREA( .T. , "DBFCDX" , "FLAGS" , "BANDERAS", .T.)
  // DBCREATEINDEX( "NOMBRE" , "NOMBRE") 
   //DBSETINDEX   ( "NOMBRE" )
      
   __dbSDF( .T. , 'PrefixGS1' )        // Write SDF File 
   
   DBCREATE("PrefixGS1", aStruct, "DBFCDX")
  
   
   DBUSEAREA( .T. , "DBFCDX" , "PrefixGS1" )
   
   __dbSDF( .F. , 'PrefixGS1' )        // Load SDF FILE into GS1.DBF
   
   PrefixGS1->(DBGOTOP())
   /*
   Do While !Eof()
         PrefixGS1->ORDEN := nOrden
         nOrden++
         PrefixGS1->(DBSKIP(1)) 
   End Do
   */
   PrefixGS1->(DBCOMMIT() )
   PrefixGS1->(DBGOBOTTOM())
   
    
     For nFor := 1 to 19         // Create Extension GS1 Prefix Country
       PrefixGS1->(DBAPPEND())
       PrefixGS1->NOMBRE     := 'USA' 
       PrefixGS1->IMAGE      := 108
       PrefixGS1->PREFIX     := IIF(nFor < 10, '00' + ALLTRIM(STR(nFor)), '0' + ALLTRIM(STR(nFor)))
       nOrden++
       PrefixGS1->(DBSKIP(1)) 
     Next
     
     For nFor := 21 to 29
       PrefixGS1->(DBAPPEND())
       PrefixGS1->NOMBRE     := 'Zrestricted' 
       PrefixGS1->IMAGE      := 121
       PrefixGS1->PREFIX     := '0' + ALLTRIM(STR(nFor))
       nOrden++
       PrefixGS1->(DBSKIP(1)) 
     Next
     
     For nFor := 40 to 49
       PrefixGS1->(DBAPPEND())
       PrefixGS1->NOMBRE     := 'Zrestricted' 
       PrefixGS1->IMAGE      := 121
       PrefixGS1->PREFIX     := '0' + ALLTRIM(STR(nFor))
       nOrden++
       PrefixGS1->(DBSKIP(1)) 
     Next
     
     GS1(200, 299 , 'Zrestricted'  , 121)
     GS1(301, 799 , 'France'       ,  34)
     GS1(401, 440 , 'Germany'      ,  36)
     GS1(451, 459 , 'Japan'        ,  51)
     GS1(490, 499 , 'Japan'        ,  51) 
     GS1(461, 469 , 'Russia'       ,  85)
     GS1(501, 509 , 'UK'           , 106)
     GS1(521, 521 , 'Greece'       ,  38)
     GS1(541, 549 , 'Belgium'      ,  10)
     GS1(571, 579 , 'Denmark'      ,  26)
     GS1(601, 601 , 'South_Africa' ,  93)
     GS1(641, 649 , 'Finland'      ,  33)
     GS1(691, 695 , 'China'        ,  19)
     GS1(701, 709 , 'Norway'       ,  76)
     GS1(731, 739 , 'Sweden'       ,  97)
     GS1(755, 755 , 'Canada'       ,  17)
     GS1(761, 769 , 'Schweiz'      ,  87)
     GS1(771, 771 , 'Colombia'     ,  20)
     GS1(779, 779 , 'Argentina'    ,   3)
     GS1(790, 790 , 'Brasil.'       ,  13)
     GS1(801, 839 , 'Italy'        ,  49)
     GS1(841, 849 , 'Spain'        ,  95)
     GS1(869, 869 , 'Turkey'       , 104)
     GS1(871, 879 , 'Netherlands'  ,  71)
     GS1(901, 919 , 'Austria'      ,   6)
     GS1(931, 939 , 'Australia'    ,   5)
     GS1(941, 949 , 'New_Zealand'  , 72)
     GS1(951, 951 , 'Zglobaloffice',115)
     GS1(961, 969 , 'Zgo_gtin8s'   ,117)
     GS1(979, 979 , 'Zisbn'        ,118)
     GS1(982, 983 , 'Zcccoupon'    ,113)
     GS1(991, 999 , 'Zcoupons'     ,114)

   PrefixGS1->(DBCOMMIT() )
   
   prefixgs1() 
   
   
     	
Return Nil

Procedure GS1(nX, nY, cGS1, nImage )
 // MSGBOX (" PAIS : "+cGS1, "Informacion")
For nFor := nX to nY  
      PrefixGS1->(DBAPPEND())  
      PrefixGS1->PREFIX  := ALLTRIM(STR( nFor   ))
      PrefixGS1->NOMBRE  := ALLTRIM(    cGS1     )
      PrefixGS1->IMAGE   := nImage 
      
      PrefixGS1->(DBSKIP(1)) 
     Next
Return


